﻿/**********************************************************************
SQL Saturday #178 (Москва, 17 ноября 2012)

Дмитрий Короткевич
"Это Мое"

http://aboutsqlserver.com
email: dmitri@aboutsqlserver.com

Блокировки - Сессия 2
ВАЖНО: Скрипт требует БД/Объектов созданных в сессии "Дизайн для производительности"
****************************************************************************/

use Pass2012
go

if exists (
	select * 
	from sys.procedures p join sys.schemas s on
		p.schema_id = s.schema_id
	where s.name = 'dbo' and p.name = 'BlockingProc'
)
	drop proc dbo.BlockingProc
go

create proc dbo.BlockingProc
as
begin
	set nocount on
	set transaction isolation level read committed

	begin tran	
		update dbo.SmallRow set CharField = 'abc' where ID = 1000
		raiserror(N'Первый update закончен',0,1) with nowait
		
		update dbo.SmallRow set CharField = 'abc' where IntField = 1000
		raiserror(N'Второй update закончен',0,1) with nowait
	commit
end
go


sp_configure 'show advanced options', 1
GO
RECONFIGURE
GO
sp_configure 'blocked process threshold', 10
GO
RECONFIGURE
GO

exec dbo.BlockingProc